/**

    Copyright 2007 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spagic.

    Spagic is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spagic is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
**/
package it.eng.console.event.action;
 
import it.eng.console.audit.bo.ProcessInstanceBO;
import it.eng.console.hibernate.util.HibernateSessionFactory;
import it.eng.console.util.Constants;
import it.eng.spago.base.SessionContainer;
import it.eng.spago.base.SourceBean;
import it.eng.spago.base.SourceBeanException;
import it.eng.spago.dispatching.action.AbstractAction;
import it.eng.spago.tracing.TracerSingleton;

import java.util.List;

import javax.xml.namespace.QName;

import org.hibernate.HibernateException;
import org.hibernate.Query;
import org.hibernate.Session;
import org.spagic.metadb.dbutils.AuditDBUtils;
import org.spagic.metadb.model.ProcessInstance;
import org.spagic.metadb.model.WaitData;

public class WaitListAction extends AbstractAction {

	
	public void service(SourceBean serviceRequest, SourceBean serviceResponse) throws Exception {		
		
		
		SessionContainer sessionContainer = getRequestContainer().getSessionContainer();
		//get Parameters from request
		//loadParametersFromRequest(serviceRequest);
		
		//save into response for pagination
		SourceBean waitDataBeanList = new SourceBean("LIST");
		//saveParametersForPagination(processBeanList);
	
		//call ProcessBO 
		List waitDataList = getWaitDataLit();
		//create response
		WaitData wd = null;		
		for(int indexProcess=0; indexProcess< waitDataList.size(); indexProcess++) {
			wd = (WaitData)waitDataList.get(indexProcess);
			if (wd!=null)
				waitDataBeanList.setAttribute(createWaitDataBean(wd, sessionContainer));				
		}
		
		//
		// The servize signal must be synchronous 
		//
			
		serviceResponse.setAttribute(waitDataBeanList);
	}
	
	
	public List getWaitDataLit() {
		Session session = null;
		try {
			session = HibernateSessionFactory.getSessionFactory()
					.getCurrentSession();
			Query q = session.createQuery(" from WaitData ");
			return q.list();
		} catch (HibernateException he) {
			TracerSingleton.log(Constants.project, TracerSingleton.CRITICAL,
					"ProcessInstanceBO::getProcessId:: ", he);
			throw he;
		}
	}
	
	
	protected SourceBean createWaitDataBean(WaitData waitData,  SessionContainer sessionContainer) 
		throws SourceBeanException {		
		SourceBean item = null;

		try {
			
			item = new SourceBean("ITEM");
			String waitId = String.valueOf(waitData.getIdWait());
			
			QName signalDestinationQName = QName.valueOf(waitData.getSignalUri());
			String signalDestinationNamespace = signalDestinationQName.getNamespaceURI();
			
			
			String version = signalDestinationNamespace.substring(signalDestinationNamespace.lastIndexOf(":")+ 1);
			signalDestinationNamespace = signalDestinationNamespace.substring(0, signalDestinationNamespace.lastIndexOf(":"));
			String processName=signalDestinationNamespace.substring(signalDestinationNamespace.lastIndexOf(":") + 1);
			
			ProcessInstance pi = AuditDBUtils.getProcessInstanceByIdCorrelation(HibernateSessionFactory.getSessionFactory()
					.getCurrentSession(), waitData.getIdCorrelation());
			String processInstanceId = String.valueOf(pi.getIdProcessInstance());
			item.setAttribute("processInstanceId", processInstanceId);
			item.setAttribute("processName", processName);
			item.setAttribute("processVersion", version);
			item.setAttribute("type", Constants.JBI_PROCESS);
			item.setAttribute("idCorrelation", waitData.getIdCorrelation());
			item.setAttribute("waitId", waitId);
			
		} catch(SourceBeanException sbe) {
			TracerSingleton.log(Constants.project, TracerSingleton.CRITICAL, "ProcessListAction::createProcessBean:: ", sbe);
			throw sbe;
		}
		
		return item;
	}
		
}
