/**

    Copyright 2007 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spagic.

    Spagic is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spagic is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
**/
package it.eng.console.tag.menu;

import it.eng.console.util.Constants;
import it.eng.spago.message.MessageBundle;
import it.eng.spago.tracing.TracerSingleton;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.jsp.JspException;
import javax.servlet.jsp.tagext.TagSupport;

public class RestartAllMenuTag extends TagSupport {
	private int position = 0;
	
    public int doStartTag() throws JspException {
        TracerSingleton.log(Constants.project, TracerSingleton.DEBUG, "RestartAllMenuTag::doStartTag:: invocato");
        if(pageContext == null) {
            TracerSingleton.log(Constants.project, TracerSingleton.CRITICAL,
                "RestartAllMenuTag::doStartTag:: pageContext nullo");
            throw new JspException("pageContext nullo");
        } 
        HttpServletRequest httpRequest = null;
        try {
            httpRequest = (HttpServletRequest) pageContext.getRequest();
        } catch(Exception ex) {
            TracerSingleton.log(
            		Constants.project, TracerSingleton.CRITICAL, "RestartAllMenuTag::doStartTag::", ex);
            throw new JspException(ex.getMessage());
        } 
        if(httpRequest == null) {
            TracerSingleton.log(Constants.project, TracerSingleton.CRITICAL, "RestartAllMenuTag::doStartTag:: httpRequest nullo");
            throw new JspException("httpRequest nullo");
        } 
        String context = httpRequest.getContextPath();
        
        StringBuffer output = new StringBuffer(); 
        String positionPx = MenuTagUtils.getPxPosition(position);
        output.append("<div style=\"position:absolute;right:" + positionPx + ";\">\n");
        output.append("<a href=\"#\" onclick=\"restartAll();return false;\">\n");
        output.append("<img src=\"" + context + "/images/console/startAll.gif\"\n");
        output.append("title=\"" + MessageBundle.getMessage("restartMultiple", "properties.spagic") + "\"\n");
        output.append("alt=\"" + MessageBundle.getMessage("restartMultiple", "properties.spagic") + "\"/>\n");
        output.append("</a>\n");
        output.append("</div>\n");
        
        try {
            pageContext.getOut().print(output.toString());
        } catch(Exception ex) {
            TracerSingleton.log(Constants.project, TracerSingleton.CRITICAL, "RestartAllMenuTag::doStartTag::", ex);
            throw new JspException(ex.getMessage());
        } 
        return SKIP_BODY;
    } 

	public int getPosition() {
		return position;
	}

	public void setPosition(int position) {
		this.position = position;
	}

	/**
     * @see javax.servlet.jsp.tagext.Tag#doEndTag()
     */
    public int doEndTag() throws JspException {
        TracerSingleton.log(Constants.project, TracerSingleton.DEBUG, "RestartAllMenuTag::doEndTag:: invocato");
        return super.doEndTag();
    } 
}
