package it.eng.spago.configuration;

import it.eng.spago.base.SourceBean;
import it.eng.spago.base.SourceBeanException;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.InputStream;

import org.xml.sax.InputSource;

/**
 * Oggetto che permette di leggere la configurazione da file, conoscendone il path.
 */
public class FileCreatorConfiguration implements IConfigurationCreator {
	
	private String rootPath = null;
	
	public FileCreatorConfiguration(String rootPath) {
		this.rootPath = rootPath;
	}
    
	public InputStream getInputStream(String resourceName) throws FileNotFoundException {
            return (new FileInputStream(rootPath + resourceName));
	}

	public SourceBean createConfiguration(String configName) throws SourceBeanException {
        SourceBean result = null;
        InputStream resourcesStream = null;
        
        try {
            resourcesStream = getInputStream(configName);
            result = SourceBean.fromXMLStream(new InputSource(resourcesStream));
        }
        catch (Exception ex) {
        	throw new SourceBeanException(ex.getMessage());
        }
        finally {
        	if (resourcesStream != null) {
        		try {
        			resourcesStream.close();
        		} catch (Exception ex) {
        			throw new SourceBeanException(ex.getMessage());
        		}
        	}
        }
        return result;
    }

}
