package it.eng.spago.services.http;

/**
 *  <p>
 *
 *  Title: </p> <p>
 *
 *  Description: </p> <p>
 *
 *  Copyright: Copyright (c) 2001</p> <p>
 *
 *  Company: Deutsche Bank Group</p>
 *
 *@author       Joan Codina
 *@company      GFT Iberia Solutions S.A.
 *@copyright    Copyright (c) 2002
 *@created      27 de enero de 2003
 *@version      1.0
 */

public class HttpBean {

    private long _expiredTime;
    private String _response;


    /**
     *  Constructor for the HttpBean object
     *
     *@param  expiration  Description of the Parameter
     */
    public HttpBean(long expiration) {
        if (expiration == -1) {
            this._expiredTime = -1;
        } else {

            this._expiredTime = System.currentTimeMillis() + expiration;
        }
    }



    /**
     *  Gets the expiration attribute of the HttpBean object
     *
     *@return    The expiration value
     */
    public boolean isExpired() {
        if (_expiredTime == -1) {
            return false;
        } else {
            return _expiredTime < System.currentTimeMillis();
        }
    }


    /**
     *  Sets the _response attribute of the HttpBean object
     *
     *@param  _response  The new _response value
     */
    public void setResponse(String response) {
        this._response = response;
    }


    /**
     *  Gets the _response attribute of the HttpBean object
     *
     *@return    The _response value
     */
    public String getResponse() {
        return _response;
    }
}
